package com.ccwangluo.im.data;

import androidx.lifecycle.MutableLiveData;
import androidx.lifecycle.ViewModel;

import com.ccwangluo.ccim.CCIMClient;
import com.ccwangluo.ccim.data.Contact;
import com.ccwangluo.ccim.data.ContactGroup;
import com.ccwangluo.ccim.data.PushChannelMsgRes;
import com.ccwangluo.ccim.data.PushPrivateMsgRes;
import com.ccwangluo.ccim.listener.ContactsCallBack;
import com.ccwangluo.ccim.listener.OnConnectListener;
import com.ccwangluo.ccim.util.HmacUtil;

import java.util.ArrayList;
import java.util.Collection;
import java.util.List;

public class LoginViewModel extends ViewModel {

    public MutableLiveData<Boolean> loginState = new MutableLiveData<>();
    public MutableLiveData<Collection<Contact>> contactList = new MutableLiveData<>();
    public MutableLiveData<Collection<ContactGroup>> contactGroupList = new MutableLiveData<>();
    public MutableLiveData<List<PushPrivateMsgRes>> privateMsgList = new MutableLiveData<>();
    public MutableLiveData<List<PushChannelMsgRes>> channelMsgList = new MutableLiveData<>();

    public MutableLiveData<List<Long>> channelList = new MutableLiveData<>();

    public void login(String username, String userId) {
        // can be launched in a separate asynchronous job
        String appKey = "c981adfde9c4000";
        Long id = Long.parseLong(userId);
        String extData = "extData";
        Long ts = System.currentTimeMillis();
        String data = appKey + "&" + id + "&" + username + "&" + extData + "&" + ts +
                "&wW7cR31PwJseIoZMOs311nljHpwUmujs";
        //sign计算在服务器,本地不要暴露appsecrect
        String sign = HmacUtil.stringToSign("wW7cR31PwJseIoZMOs311nljHpwUmujs", data);
        CCIMClient.getInstance().initSDK(appKey, username, extData, id, ts, sign, new OnConnectListener() {
            @Override
            public void onSocketConnection() {
                loginState.postValue(true);
            }

            @Override
            public void onSocketDisconnection() {
//                loginState.postValue(false);
//                System.out.println("链接断开");
            }
        });
    }

    public void getContactList() {
        CCIMClient.getInstance().getContactList(new ContactsCallBack() {
            @Override
            public void onSuccess(Collection<Contact> contacts, Collection<ContactGroup> contactGroups) {
                contactList.postValue(contacts);
                contactGroupList.postValue(contactGroups);
            }
        });
    }

    public void addChannelId(long id) {
        List<Long> value = channelList.getValue();
        if (value == null) {
            value = new ArrayList<>();
        }
        value.add(id);
        channelList.postValue(value);

    }

    public void removeChannelId(long id) {
        List<Long> value = channelList.getValue();
        if (value == null) {
            return;
        }
        value.remove(id);
        channelList.postValue(value);
    }

    public void addPrivateMsg(PushPrivateMsgRes res) {
        List<PushPrivateMsgRes> value = privateMsgList.getValue();
        if (value == null) {
            value = new ArrayList<>();
        }
        value.add(res);
        privateMsgList.postValue(value);
    }

    public void addChannelMsg(PushChannelMsgRes res) {
        List<PushChannelMsgRes> value = channelMsgList.getValue();
        if (value == null) {
            value = new ArrayList<>();
        }
        value.add(res);
        channelMsgList.postValue(value);
    }
}